import os

import pytest

_THIS_DIR = os.path.dirname(os.path.realpath(__file__))


@pytest.fixture
def get_one_float_json():
    return os.path.join(_THIS_DIR, "test_files", "one_float.json")


@pytest.fixture
def get_multiple_choice_json():
    return os.path.join(_THIS_DIR, "test_files", "multiple_choice.json")


@pytest.fixture
def get_report_file():
    return os.path.join(_THIS_DIR, "test_files", "report.json")


@pytest.fixture
def get_report_file_mcq():
    return os.path.join(_THIS_DIR, "test_files", "to_analyze", "report_mcq.json")


@pytest.fixture
def cached_langchain_llm():
    import langchain
    from dotenv import load_dotenv
    from langchain.cache import SQLiteCache
    from langchain_openai import OpenAI

    load_dotenv()
    langchain.llm_cache = SQLiteCache(database_path=".langchain.db")
    llm = OpenAI()
    return llm


@pytest.fixture
def cached_langchain_chat_model():
    import langchain
    from dotenv import load_dotenv
    from langchain.cache import SQLiteCache
    from langchain_openai import ChatOpenAI

    load_dotenv()
    langchain.llm_cache = SQLiteCache(database_path=".langchain.db")
    llm = ChatOpenAI()
    return llm
